/***********************************************************************/
/* File : CSCL(Constraint Satisfy Check Library) */

#ifndef __SLAM_LEVEL_TYPE_H
#define __SLAM_LEVEL_TYPE_H

#include "__slam_tag_type.h"
#include "__slam_list.h"

/***********************************************************************/
/* Define Macro. */

#define CACHE_TABLE_SIZE	127

/***********************************************************************/
/* Data struct */

//! CacheѤΥơ֥
typedef struct __slam_cache_data {
    int				 key;
    __slam_boolean_t		 result;
    struct __slam_cache_data	*next;
} __slam_cache_data_t;

typedef __slam_cache_data_t	*__slam_cache_table_t;

typedef struct __slam_level	*__slam_level_t;

/* Level: Tagν */
typedef struct __slam_level {
    int			 id;
	/* ǻѤ륿ο			 */
    int			 num_of_tag;
	/* ǻѤ륿ν(Lattice)Listɽ	 */
    __slam_list_t	*lattice;
#ifdef TO_ARRAY
	/* ǻѤ륿ν(Lattice)ɽ	 */
    __slam_tag_t	*lattice_array;
#endif
	/* level֤leqη̡levelʲlevelϿ		*/
    __slam_cache_table_t	*result_cache_leq;
	/* ¾levelƱΤ */
    __slam_boolean_t	is_same;
} __slam_level_type;

#endif
