/***********************************************************************/
/* File : CSCL(Constraint Satisfy Check Library) */

#ifndef RULE_H
#define RULE_H

#include "__slam_rule_type.h"
#include "__slam_boolean.h"

/***********************************************************************/
/* Global Variable */

/***********************************************************************/
/* External Function */

extern void __slam_rule_init(
    void);

extern void __slam_rule_term(
    void);

extern void __slam_add_rule(
    __slam_tag_t	small_tag,
    __slam_tag_t	big_tag);

extern void __slam_force_add_rule(
    __slam_tag_t	small_tag,
    __slam_tag_t	big_tag);

#ifndef NDEBUG
extern void __slam_rule_dump(
    FILE		*file,
    __slam_rule_t	rule);

extern void __slam_rule_all_dump(
    FILE	*file);
#endif

#endif
