/***********************************************************************/
/* File : CSCL(Constraint Satisfy Check Library) */
#include <stdlib.h>
#include <stdio.h>
#include <assert.h>
#include <stdarg.h>

#include "__slam.h"
#include "__slam_level.h"
#include "__slam_tag.h"
#include "__slam_rule.h"
#include "__slam_list.h"
#include "__slam_graph.h"

/***********************************************************************/
/* Static Variable */

/***********************************************************************/
/* Static Function Decl. */

/***********************************************************************/
/* External Function */

/* 饤֥ν */
extern void __slam_init(
    void)
{
    /* Listν */
    __slam_list_init();

    __slam_level_init();
    __slam_rule_init();
    __slam_tag_init();

#ifndef NDEBUG
    debug_file = fopen("debug.info", "w");
#endif
}

/* 饤֥νλ */
extern void __slam_term(
    void)
{
#ifndef NDEBUG_USE_GRAPH
    __slam_graph_dump();
#endif

    __slam_tag_term();
    __slam_rule_term();
    __slam_level_term();

    __slam_list_term();
}

